#!/usr/bin/perl
# edit_printer.cgi
# Edit or create a printer

require './cupsadmin-lib.pl';
&ReadParse();
if ($in{'new'}) {
	$access{'add'} || &error($text{'edit_eadd'});
	&header($text{'edit_add'}, "");
	$prn{'accepting'}++;
	$prn{'enabled'}++;
	$prn{'allow_all'}++;
	$prn{'dev'} = $device_files[0];
	$prn{'ctype'} = [ "postscript" ];
}
else {
	&can_edit_printer($in{'name'}) || &error($text{'edit_eedit'});
	&header($text{'cups_edit'}, "");
	%prn = %{&get_printer($in{'name'})};
        &Read_Conf() ; # now add the cups data to %prn
}
print "<hr>\n";

print "<form action=save_printer.cgi>\n";
print "<table border width=100%>\n";
print "<tr $tb> <td><b>$text{'cups_conf'}</b></td> </tr>\n";
print "<tr $cb> <td><table width=100%>\n";

print "<tr> <td><b>$text{'edit_name'}</b></td>\n";
if ($in{'new'}) {
	print "<td><input name=name size=15></td>\n";
	print "<input type=hidden name=new value=1>\n";
	}
else {
	print "<td>$prn{'name'}</td>\n";
	print "<input type=hidden name=name value=\"$prn{'name'}\">\n";
	}

print "<td align=right><b>$text{'edit_acc'}</b></td>\n";
printf "<td><input type=radio name=accepting value=1 %s> $text{'yes'}\n",
	$prn{'accepting'} ? "checked" : "";
if (&printer_support('why')) {
	printf "<input type=radio name=accepting value=0 %s> %s\n",
		$prn{'accepting'} ? "" : "checked", $text{'edit_why'};
	printf "<input name=accepting_why size=15 value=\"%s\"></td> </tr>\n",
		$prn{'accepting_why'};
	}
else {
	printf "<input type=radio name=accepting value=0 %s> $text{'no'}\n",
		$prn{'accepting'} ? "" : "checked";
	}

if (&printer_support('desc')) {
	print "<tr> <td><b>$text{'edit_desc'}</b></td>\n";
	print "<td><input name=desc size=20 value=\"$prn{'desc'}\"></td>\n";
	print "<tr> <td><b>$text{'edit_location'}</b></td>\n";
	print "<td><input name=location size=20 value=\"$prn{'location'}\"></td>\n";
	}
else { print "<tr> <td colspan=2></td>\n"; }

print "<td align=right><b>$text{'edit_ena'}</b></td>\n";
printf "<td><input type=radio name=enabled value=1 %s> $text{'yes'}\n",
	$prn{'enabled'} ? "checked" : "";
if (&printer_support('why')) {
	printf "<input type=radio name=enabled value=0 %s> %s\n",
		$prn{'enabled'} ? "" : "checked", $text{'edit_why'};
	printf "<input name=enabled_why size=15 value=\"%s\"></td> </tr>\n",
		$prn{'enabled_why'};
	}
else {
	printf "<input type=radio name=enabled value=0 %s> $text{'no'}\n",
		$prn{'enabled'} ? "" : "checked";
	}

if (&printer_support('allow')) {
	print "<tr> <td valign=top><b>$text{'edit_acl'}</b></td>\n";
	print "<td colspan=3><table><tr><td valign=top>\n";
	printf "<input type=radio name=access value=0 %s> %s<br>\n",
		$prn{'allow_all'} ? "checked" : "", $text{'edit_allow'};
	printf "<input type=radio name=access value=1 %s> %s<br>\n",
		$prn{'deny_all'} ? "checked" : "", $text{'edit_deny'};
	printf "<input type=radio name=access value=2 %s> %s<br>\n",
		$prn{'allow'} ? "checked" : "", $text{'edit_allowu'};
	printf "<input type=radio name=access value=3 %s> %s\n",
		$prn{'deny'} ? "checked" : "", $text{'edit_denyu'};
	print "</td> <td valign=top>\n";
	print "<textarea wrap=auto name=users rows=5 cols=30>",
	      join(" ", (@{$prn{'allow'}}, @{$prn{'deny'}})),
	      "</textarea></td>\n";
	print "<td valign=top>",&user_chooser_button("users",1),"</td>\n";
	print "</tr></table></td> </tr>\n";
	}

if (&printer_support('banner')) {
	print "<tr> <td valign=top><b>$text{'edit_banner'}</b></td> ",
	      "<td valign=top>\n";
	printf "<input type=radio name=banner value=1 %s> $text{'yes'}\n",
		$prn{'banner'} ? "checked" : "";
	printf "<input type=radio name=banner value=0 %s> %s</td>\n",
		$prn{'banner'} ? "" : "checked", $text{'edit_opt'};
	}
else { print "<tr>\n"; }

if (&printer_support('default')) {
	print "<td align=right><b>$text{'edit_default'}</b></td> <td>\n";
	if (!$prn{'default'}) {
		printf "<input type=radio name=default value=1 %s> $text{'yes'}\n", $prn{'default'} ? "checked" : "";
		printf "<input type=radio name=default value=0 %s> $text{'no'}</td></tr>\n", $prn{'default'} ? "" : "checked";
		}
	else {
		print "<i>$text{'edit_already'}</i> </td> </tr>\n";
		}
	}
elsif (&printer_support('msize')) {
	print "<td align=right><b>$text{'edit_max'}</b></td> <td>\n";
	printf "<input type=radio name=msize_def value=1 %s> %s\n",
		defined($prn{'msize'}) ? "" : "checked", $text{'default'};
	printf "<input type=radio name=msize_def value=2 %s> %s\n",
		$prn{'msize'} eq '0' ? "checked" : "", $text{'edit_unlimited'};
	printf "<input type=radio name=msize_def value=0 %s>\n",
		$prn{'msize'} ? "checked" : "";
	printf "<input name=msize size=6 value=\"%s\"> %s</td> </tr>\n",
		$prn{'msize'} ? $prn{'msize'} : "", $text{'blocks'};
	}
else { print "<td colspan=2></tr>\n"; }

if (&printer_support('ctype')) {
	@ctype = @{$prn{'ctype'}};
	print "<tr> <td><b>$text{'edit_dacc'}</b></td> <td colspan=3>\n";
	printf "<input type=checkbox name=ctype_simple %s> %s &nbsp;\n",
		&indexof("simple", @ctype) < 0 ? "" : "checked",
		$text{'edit_dtext'};
	printf "<input type=checkbox name=ctype_postscript %s> %s &nbsp;\n",
		&indexof("postscript", @ctype) < 0 ? "" : "checked",
		$text{'edit_dpost'};
	@ctypeo = grep { !/^(simple|postscript)$/ } @ctype;
	printf "<input type=checkbox name=ctype_other %s> %s\n",
		@ctypeo ? "checked" : "", $text{'edit_dother'};
	printf "<input name=ctype_olist size=20 value=\"%s\">\n",
		join(' ', @ctypeo);
	print "</td> </tr>\n";
	}

if (&printer_support('alias')) {
	@alias = @{$prn{'alias'}};
	print "<tr> <td><b>$text{'edit_alt'}</b></td> <td colspan=3>\n";
	printf "<input name=alias size=40 value=\"%s\"></td> </tr>\n",
		join(' ', @alias);
	}

print "</table></td></tr></table><p>\n";

if ($in{'new'} || &printer_support('editdest')) {
	print "<table border width=100%>\n";
	print "<tr $tb> <td><b>$text{'cups_dest'}</b></td> </tr>\n";
	print "<tr $cb> <td><table>\n";

	$isdev = &indexof($prn{'dev'}, @device_files) >= 0;
	if (!$webmin_windows_driver) {
		$wdrv = &is_webmin_windows_driver($prn{'iface'}, \%prn);
		$webmin++ if ($wdrv);
		}
	$wdrv = &is_windows_driver($prn{'iface'}, \%prn) if (!$wdrv);
	$hdrv = &is_hpnp_driver($prn{'iface'}, \%prn);
	if ($wdrv) { $prn{'iface'} = $wdrv->{'program'}; }
	elsif ($hdrv) { $prn{'iface'} = $hdrv->{'program'}; }

        if ( $prn{'cups_dev'} == 1 or $prn{'cups_dev'} eq '' )
        {
          $checked = 'checked' ;
        }
        else
        {
          $checked = '' ;
        }
	printf "<tr> <td><input type=radio name=cups_dev value=1 %s> %s</td>\n",
		$checked,
		$text{'edit_dev'};
	print "<td><select name=ldev>\n";
	for($i=0; $i<@device_names_local; $i++) {
		$d = $device_names_local[$i];
		printf "<option value=\"$d\" %s>$device_names_local[$i]\n",
                        $d eq $prn{'ldev'} ? "selected" : "";
		}
	print "</select></td></tr>\n";
	print "<tr><td></td><td>$text{'cups_baud'} <select name=cups_baud>\n";
	for($i=0; $i<@cups_baud; $i++) {
		$d = $cups_baud[$i];
		printf "<option value=\"$d\" %s>$cups_baud[$i]\n",
                        $d eq $prn{'cups_baud'} ? "selected" : "";
		}
        print "</select></td>\n" ;
        print "<td>$text{'cups_parity'} <select name=cups_parity>\n" ;
	for($i=0; $i<@cups_parity; $i++) {
		$d = $cups_parity[$i];
		printf "<option value=\"$d\" %s>$cups_parity[$i]\n",
                        $d eq $prn{'cups_parity'} ? "selected" : "";
		}
        print "</select></td></tr>\n";
	print "</select></td></tr>\n";
	print "<tr><td></td><td>$text{'cups_data_bits'} <select name=cups_databits>\n";
	for($i=0; $i<@cups_data_bits; $i++) {
		$d = $cups_data_bits[$i];
		printf "<option value=\"$d\" %s>$cups_data_bits[$i]\n",
                        $d eq $prn{'cups_databits'} ? "selected" : "";
		}
        print "</select></td>\n" ;
        print "<td>$text{'cups_flow_control'} <select name=cups_flow>\n" ;
	for($i=0; $i<@cups_flow; $i++) {
		$d = $cups_flow[$i];
		printf "<option value=\"$d\" %s>$cups_flow[$i]\n",
                        $d eq $prn{'cups_flow'} ? "selected" : "";
		}
        print "</select></td></tr>\n";

        if ( $prn{'cups_dev'} == 2 )
        {
          $checked = 'checked' ;
        }
        else
        {
          $checked = '' ;
        }
	printf "<tr> <td><input type=radio name=cups_dev value=2 %s>$text{'edit_file'} %s</td>\n",
		$checked,
		$prn{'cups_file'};
	printf "<td><input name=cups_file size=25 value=\"%s\"></td>\n",
		$prn{'cups_file'} ? $prn{'cups_file'} : "" ;
        print "<td>$text{'cups_file_ex'}</td></tr>\n" ;

        if ( $prn{'cups_dev'} == 3 )
        {
          $checked = 'checked' ;
        }
        else
        {
          $checked = '' ;
        }
	printf "<tr> <td><input type=radio name=cups_dev value=3 %s>\n",
		$checked ;
	print "$text{'cups_device'}</td>\n";
	print "<td><select name=cups_uri_dev>\n";
	for($i=0; $i<@device_names_uri; $i++) {
		$d = $device_names_uri[$i];
		printf "<option value=\"$d\" %s>$device_names_uri[$i]\n",
                        $d eq $prn{'cups_uri_dev'} ? "selected" : "";
		}
	print "</select></td> </tr>\n";

	print "<tr><td></td><td>$text{'cups_uri'}<input name=cups_uri size=25 value=\"$prn{'cups_uri'}\"></td></tr>\n";

        print "<tr><td></td><td>$text{'cups_uri_ex1'}</td></tr>\n" ;
        print "<tr><td></td><td>$text{'cups_uri_ex2'}</td></tr>\n" ;
        print "<tr><td></td><td>$text{'cups_uri_ex3'}</td></tr>\n" ;
        print "<tr><td></td><td>$text{'cups_uri_ex4'}</td></tr>\n" ;
        print "<tr><td></td><td>$text{'cups_uri_ex5'}</td></tr>\n" ;
        print "<tr><td></td><td>$text{'cups_uri_ex6'}</td></tr>\n" ;
        print "<tr><td></td><td>$text{'cups_uri_ex7'}</td></tr>\n" ;
        print "<tr><td></td><td>$text{'cups_uri_ex8'}</td></tr>\n" ;

	print "</table></td></tr></table><p>\n";

	print "<table border width=100%>\n";
	print "<tr $tb> <td><b>$text{'cups_driver'} </b></td></tr>\n";
	print "<tr $cb> <td><table width=100%>\n";
	print "<tr><td></td>\n";

        if ( $prn{'cups_driver'} eq '' )
        {
          $prn{'cups_driver'} = @cups_drivers[0] ;
        }
	for($i=0; $i<@cups_drivers; $i++) {
                $driver = $cups_drivers[$i] ;
	        printf "<tr> <td><input type=radio name=cups_driver value=$i %s>\n",
                $driver eq $prn{'cups_driver'} ? 'checked' : '' ;
	        print "$driver</td>\n";
                printf "<td><select name=cups_model>\n" ;
                eval { $cups_ptr = \@$driver } ;
                print "<option>" ;
                for ($j=0; $j<@$cups_ptr; $j++) {
                  $d = $$cups_ptr[$j] ;
		  printf "<option value=\"$d\" %s>$d\n",
                        $d eq $prn{'cups_model'} ? "selected" : " ";
                }
                print "</td></tr>\n" ;
	}
	print "</table></td></tr></table><p>\n";
        }
print "<input type=hidden name=webmin value=\"$webmin\">\n";

if ($in{'new'}) {
	print "<input type=submit value=\"$text{'create'}\"></form><p>\n";
	}
else {
	print "<table width=100%>\n";
	print "<tr> <td><input type=submit value=\"$text{'save'}\"></td>\n";
	print "</form><form action=delete_printer.cgi>\n";
	print "<input type=hidden name=name value=\"$in{'name'}\">\n";
	print "<td align=right><input type=submit ",
	      "value=\"$text{'delete'}\"></td> </tr>\n";
	print "</form></table><p>\n";
	}
print $after;

print "<hr>\n";
&footer("", $text{'index_return'});

